/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreMissingDeDeRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreMissingDeDe extends TableImpl<VCoreMissingDeDeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_missing_de_de</code>
     */
    public static final VCoreMissingDeDe V_CORE_MISSING_DE_DE = new VCoreMissingDeDe();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreMissingDeDeRecord> getRecordType() {
        return VCoreMissingDeDeRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_missing_de_de.fk_missinglist</code>.
     */
    public final TableField<VCoreMissingDeDeRecord, Integer> FK_MISSINGLIST = createField(DSL.name("fk_missinglist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_missing_de_de.missing_value</code>.
     */
    public final TableField<VCoreMissingDeDeRecord, Integer> MISSING_VALUE = createField(DSL.name("missing_value"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_missing_de_de.value_lang</code>.
     */
    public final TableField<VCoreMissingDeDeRecord, String> VALUE_LANG = createField(DSL.name("value_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_missing_de_de.de_de</code>.
     */
    public final TableField<VCoreMissingDeDeRecord, String> DE_DE = createField(DSL.name("de_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_missing_de_de.num_missingcode</code>.
     */
    public final TableField<VCoreMissingDeDeRecord, Integer> NUM_MISSINGCODE = createField(DSL.name("num_missingcode"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_missing_de_de.sas_missingcode</code>.
     */
    public final TableField<VCoreMissingDeDeRecord, String> SAS_MISSINGCODE = createField(DSL.name("sas_missingcode"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_missing_de_de.date_missingcode</code>.
     */
    public final TableField<VCoreMissingDeDeRecord, LocalDateTime> DATE_MISSINGCODE = createField(DSL.name("date_missingcode"), SQLDataType.LOCALDATETIME(6), this, "");

    private VCoreMissingDeDe(Name alias, Table<VCoreMissingDeDeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreMissingDeDe(Name alias, Table<VCoreMissingDeDeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_missing_de_de" as  SELECT t_core_missingvalue.fk_missinglist,
          t_core_missingvalue.fk_missingmaster AS missing_value,
          t_core_missingmaster.fk_lang AS value_lang,
          t_core_translation.value AS de_de,
          mc.num_missingcode,
          mc.sas_missingcode,
          mc.date_missingcode
         FROM ((((common_dd.t_core_missingvalue
           LEFT JOIN common_dd.t_core_missingmaster ON ((t_core_missingmaster.pk = t_core_missingvalue.fk_missingmaster)))
           LEFT JOIN common_dd.t_core_translation ON ((t_core_translation.fk_trans_key = t_core_missingmaster.fk_lang)))
           LEFT JOIN common_dd.t_dm_missingvalue ON ((t_core_missingvalue.pk = t_dm_missingvalue.fk_core_missingvalue)))
           LEFT JOIN common_dd.t_dm_missingcode mc ON ((mc.pk = t_dm_missingvalue.fk_missingcode)))
        WHERE (((t_core_translation.isocode = 'de_DE'::common_dd.enum_isocode) AND (t_core_translation.category = 'crf'::common_dd.enum_trans_category)) OR (t_core_translation.isocode IS NULL));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missing_de_de</code> table
     * reference
     */
    public VCoreMissingDeDe(String alias) {
        this(DSL.name(alias), V_CORE_MISSING_DE_DE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missing_de_de</code> table
     * reference
     */
    public VCoreMissingDeDe(Name alias) {
        this(alias, V_CORE_MISSING_DE_DE);
    }

    /**
     * Create a <code>common_dd.v_core_missing_de_de</code> table reference
     */
    public VCoreMissingDeDe() {
        this(DSL.name("v_core_missing_de_de"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreMissingDeDe as(String alias) {
        return new VCoreMissingDeDe(DSL.name(alias), this);
    }

    @Override
    public VCoreMissingDeDe as(Name alias) {
        return new VCoreMissingDeDe(alias, this);
    }

    @Override
    public VCoreMissingDeDe as(Table<?> alias) {
        return new VCoreMissingDeDe(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissingDeDe rename(String name) {
        return new VCoreMissingDeDe(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissingDeDe rename(Name name) {
        return new VCoreMissingDeDe(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissingDeDe rename(Table<?> name) {
        return new VCoreMissingDeDe(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissingDeDe where(Condition condition) {
        return new VCoreMissingDeDe(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissingDeDe where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissingDeDe where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissingDeDe where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissingDeDe where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissingDeDe where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissingDeDe where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissingDeDe where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissingDeDe whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissingDeDe whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
